// Code generated by gobind. DO NOT EDIT.

// Java class org.ethereum.geth.KeyStore is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
package org.ethereum.geth;

import go.Seq;

/**
 * KeyStore manages a key storage directory on disk.
 */
public final class KeyStore implements Seq.Proxy {
	static { Geth.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewKeyStore creates a keystore for the given directory.
	 */
	public KeyStore(String keydir, long scryptN, long scryptP) {
		this.refnum = __NewKeyStore(keydir, scryptN, scryptP);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewKeyStore(String keydir, long scryptN, long scryptP);
	
	KeyStore(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * DeleteAccount deletes the key matched by account if the passphrase is correct.
	If a contains no filename, the address must match a unique key.
	 */
	public native void deleteAccount(Account account, String passphrase) throws Exception;
	/**
	 * ExportKey exports as a JSON key, encrypted with newPassphrase.
	 */
	public native byte[] exportKey(Account account, String passphrase, String newPassphrase) throws Exception;
	/**
	 * GetAccounts returns all key files present in the directory.
	 */
	public native Accounts getAccounts();
	/**
	 * HasAddress reports whether a key with the given address is present.
	 */
	public native boolean hasAddress(Address address);
	/**
	 * ImportECDSAKey stores the given encrypted JSON key into the key directory.
	 */
	public native Account importECDSAKey(byte[] key, String passphrase) throws Exception;
	/**
	 * ImportKey stores the given encrypted JSON key into the key directory.
	 */
	public native Account importKey(byte[] keyJSON, String passphrase, String newPassphrase) throws Exception;
	/**
	 * ImportPreSaleKey decrypts the given Ethereum presale wallet and stores
	a key file in the key directory. The key file is encrypted with the same passphrase.
	 */
	public native Account importPreSaleKey(byte[] keyJSON, String passphrase) throws Exception;
	/**
	 * Lock removes the private key with the given address from memory.
	 */
	public native void lock(Address address) throws Exception;
	/**
	 * NewAccount generates a new key and stores it into the key directory,
	encrypting it with the passphrase.
	 */
	public native Account newAccount(String passphrase) throws Exception;
	/**
	 * SignHash calculates a ECDSA signature for the given hash. The produced signature
	is in the [R || S || V] format where V is 0 or 1.
	 */
	public native byte[] signHash(Address address, byte[] hash) throws Exception;
	/**
	 * SignHashPassphrase signs hash if the private key matching the given address can
	be decrypted with the given passphrase. The produced signature is in the
	[R || S || V] format where V is 0 or 1.
	 */
	public native byte[] signHashPassphrase(Account account, String passphrase, byte[] hash) throws Exception;
	/**
	 * SignTx signs the given transaction with the requested account.
	 */
	public native Transaction signTx(Account account, Transaction tx, BigInt chainID) throws Exception;
	/**
	 * SignTxPassphrase signs the transaction if the private key matching the
	given address can be decrypted with the given passphrase.
	 */
	public native Transaction signTxPassphrase(Account account, String passphrase, Transaction tx, BigInt chainID) throws Exception;
	/**
	 * TimedUnlock unlocks the given account with the passphrase. The account stays
	unlocked for the duration of timeout (nanoseconds). A timeout of 0 unlocks the
	account until the program exits. The account must match a unique key file.
	
	If the account address is already unlocked for a duration, TimedUnlock extends or
	shortens the active unlock timeout. If the address was previously unlocked
	indefinitely the timeout is not altered.
	 */
	public native void timedUnlock(Account account, String passphrase, long timeout) throws Exception;
	/**
	 * Unlock unlocks the given account indefinitely.
	 */
	public native void unlock(Account account, String passphrase) throws Exception;
	/**
	 * UpdateAccount changes the passphrase of an existing account.
	 */
	public native void updateAccount(Account account, String passphrase, String newPassphrase) throws Exception;
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof KeyStore)) {
		    return false;
		}
		KeyStore that = (KeyStore)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("KeyStore").append("{");
		return b.append("}").toString();
	}
}

